Object subclass: #NamedObjectHome
	instanceVariableNames: 'objectDict tempObjectCounter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!NamedObjectHome commentStamp: 'MU 11/12/2000 01:30' prior: 0!
I am used for tiny naming service. Currently I just delegate requests to dictionary.
I should do some remote garbage collection.!


!NamedObjectHome methodsFor: 'initialize-release' stamp: 'MU 11/20/2000 00:58'!
initialize
	objectDict := IdentityDictionary new.
	tempObjectCounter := 0.! !


!NamedObjectHome methodsFor: 'actions' stamp: 'MU 11/20/2000 00:17'!
at: aSymbol
	^ objectDict at: aSymbol ifAbsent:[OperaError noImplement signal]! !

!NamedObjectHome methodsFor: 'actions' stamp: 'mu 10/30/2000 14:40'!
at: aSymbol ifAbsent: aBlock
	^ objectDict at: aSymbol ifAbsent: aBlock! !

!NamedObjectHome methodsFor: 'actions' stamp: 'MU 11/20/2000 01:08'!
at: aSymbol ifAbsentPut: aBlock
	self checkCleanTempObjects.
	^ objectDict at: aSymbol ifAbsentPut: aBlock! !

!NamedObjectHome methodsFor: 'actions' stamp: 'MU 11/20/2000 01:30'!
at: aSymbol put: anObject 
	self checkCleanTempObjects.
	^ objectDict at: aSymbol put: anObject! !


!NamedObjectHome methodsFor: 'factory' stamp: 'MU 11/20/2000 00:20'!
defaultDictionary
	^IdentityDictionary new! !


!NamedObjectHome methodsFor: 'private' stamp: 'MU 11/26/2000 19:20'!
checkCleanTempObjects
	tempObjectCounter := tempObjectCounter + 1.
	tempObjectCounter > 9999
		ifTrue: 
			[[objectDict keysAndValuesRemove: [:key :value | key beginsWith: #temp:]] valueUninterruptably.
			tempObjectCounter := 0]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NamedObjectHome class
	instanceVariableNames: 'default '!

!NamedObjectHome class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:29'!
new
	^super new initialize! !


Error subclass: #OperaError
	instanceVariableNames: 'originalError minorCode description '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaError commentStamp: 'MU 11/26/2000 19:03' prior: 0!
I represent a distributed exception occured in OperaORB.
Currently, I cannot distinguish system level exception and application defined exception.
!


!OperaError methodsFor: 'accessing' stamp: 'MU 11/20/2000 00:19'!
description

	^description! !

!OperaError methodsFor: 'accessing' stamp: 'MU 11/20/2000 00:19'!
description: aValue

	description := aValue! !

!OperaError methodsFor: 'accessing' stamp: 'MU 11/20/2000 00:19'!
minorCode

	^minorCode! !

!OperaError methodsFor: 'accessing' stamp: 'MU 11/20/2000 00:19'!
minorCode: aValue

	minorCode := aValue! !

!OperaError methodsFor: 'accessing' stamp: 'MU 11/26/2000 00:48'!
originalError

	^originalError! !

!OperaError methodsFor: 'accessing' stamp: 'MU 11/26/2000 00:48'!
originalError: aValue

	originalError := aValue! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaError class
	instanceVariableNames: ''!

!OperaError class methodsFor: 'defaults' stamp: 'MU 11/26/2000 00:24'!
badParameter
	^self new messageText: #'BAD_PARAM'! !

!OperaError class methodsFor: 'defaults' stamp: 'MU 11/20/2000 00:14'!
noImplement
	^self new messageText: #'NO_IMPLEMENT'! !


!OperaError class methodsFor: 'instance creation' stamp: 'MU 11/26/2000 01:03'!
fromSoapError: aSoapError
	| inst |
	"##needs more work##"
	inst := self new.
	inst originalError: aSoapError.
	inst description: (aSoapError description copyReplaceAll: 'SoapError:' with: 'OperaError:').
	inst messageText: aSoapError messageText.
	inst minorCode: #Unknown.
	^inst! !


Object subclass: #OperaORB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaORB commentStamp: 'MU 11/26/2000 19:04' prior: 0!
I am a facade of ORB.
Many features are not implemented yet.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaORB class
	instanceVariableNames: ''!

!OperaORB class methodsFor: 'accessing' stamp: 'MU 11/26/2000 00:09'!
rootOOA
	^OperaObjectAdapter root! !


!OperaORB class methodsFor: 'actions' stamp: 'MU 11/26/2000 00:08'!
init
	self init: (OperaSetting default defaultPort)! !

!OperaORB class methodsFor: 'actions' stamp: 'MU 11/26/2000 00:07'!
init: aPort! !

!OperaORB class methodsFor: 'actions' stamp: 'MU 11/26/2000 00:07'!
shutdown! !


!OperaORB class methodsFor: 'utility' stamp: 'MU 11/26/2000 03:04'!
debugMode: aBoolean
	SoapHttpModule debugMode: aBoolean! !

!OperaORB class methodsFor: 'utility' stamp: 'MU 11/26/2000 01:50'!
launch
	"##need more work##"
	SoapHttpModuleSetup launch.! !


Object subclass: #OperaObjectReference
	instanceVariableNames: 'name host port impl '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaObjectReference commentStamp: '<historical>' prior: 0!
I represent an object reference.
I am passed through the wire and converted as a stub (RemoteObject).!


!OperaObjectReference methodsFor: 'initialize-release' stamp: 'MU 11/19/2000 23:54'!
initialize
	host := OperaSetting default defaultHost.
	port := OperaSetting default defaultPort.! !


!OperaObjectReference methodsFor: 'converting' stamp: 'MU 11/18/2000 01:36'!
asRemoteObject
	^RemoteObject name: (self name) host: (self host) port: (self port) ! !


!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/18/2000 01:06'!
host
	
	^host! !

!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/18/2000 00:48'!
host: aValue

	host := aValue! !

!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/19/2000 23:30'!
impl
	
	^impl! !

!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/19/2000 23:30'!
impl: aValue

	impl := aValue! !

!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/18/2000 00:48'!
name

	^name! !

!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/18/2000 00:48'!
name: aValue

	name := aValue! !

!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/18/2000 01:05'!
port
	
	^port! !

!OperaObjectReference methodsFor: 'accessing' stamp: 'MU 11/18/2000 00:48'!
port: aValue

	port := aValue! !


!OperaObjectReference methodsFor: 'object from disk' stamp: 'MU 12/28/2000 00:18'!
readDataFrom: aDataStream size: varsOnDisk 
	| cntInstVars |
	cntInstVars := varsOnDisk.
	"OK if fewer than now"
	aDataStream beginReference: self.
	1 to: cntInstVars do: [:i | self instVarAt: i put: aDataStream next]! !

!OperaObjectReference methodsFor: 'object from disk' stamp: 'MU 12/28/2000 00:18'!
storeDataOn: aDataStream 
	| cntInstVars |
	cntInstVars := self class instSize - 1.
	"remove impl"
	aDataStream beginInstance: self class size: cntInstVars.
	1 to: cntInstVars do: [:i | aDataStream nextPut: (self instVarAt: i)]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaObjectReference class
	instanceVariableNames: ''!

!OperaObjectReference class methodsFor: 'instance creation' stamp: 'MU 11/19/2000 23:54'!
new
	^super new initialize! !

!OperaObjectReference class methodsFor: 'instance creation' stamp: 'MU 11/19/2000 23:30'!
on: anObject
	^self new impl: anObject! !


!OperaObjectReference class methodsFor: 'comparing' stamp: 'MU 11/26/2000 01:11'!
hasInstance: anObject
	"performance conscious comparison"
	^anObject class name == self name! !


DataStream subclass: #OperaObjectStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaObjectStream commentStamp: 'MU 11/12/2000 01:37' prior: 0!
Simple object stream. Actually, I inherit main features from DataStream.
Language independent marshaling/unmarshaling stream will be needed.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaObjectStream class
	instanceVariableNames: ''!

!OperaObjectStream class methodsFor: 'marshal/unmarshal' stamp: 'MU 11/7/2000 16:58'!
objectFromString: aString
	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := self on: byteStr.
	^oStr next! !

!OperaObjectStream class methodsFor: 'marshal/unmarshal' stamp: 'MU 11/9/2000 11:57'!
stringFromObject: anObject 
	| file con |
	file := RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	file binary.
	(self on: file)
		nextPut: anObject.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^ con contents! !


Object subclass: #OperaOidGenerator
	instanceVariableNames: 'highValue lowValue highValueCounter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaOidGenerator commentStamp: 'MU 11/26/2000 19:06' prior: 0!
I am a simple OID(Object ID) generator.!


!OperaOidGenerator methodsFor: 'initialize-release' stamp: 'M.U 6/6/1999 00:58'!
initialize
	highValueCounter := 0.! !


!OperaOidGenerator methodsFor: 'actions' stamp: 'MU 11/20/2000 00:30'!
nextValue
	^(self nextHighValue , self nextLowValue)! !


!OperaOidGenerator methodsFor: 'accessing' stamp: 'M.U 6/6/1999 01:04'!
highValue

	highValue isNil ifTrue:[ highValue := self privNextValue. ].

	^highValue! !

!OperaOidGenerator methodsFor: 'accessing' stamp: 'M.U 6/6/1999 00:49'!
highValue: aValue

	highValue := aValue! !

!OperaOidGenerator methodsFor: 'accessing' stamp: 'M.U 6/6/1999 00:58'!
highValueCounter
	^highValueCounter! !

!OperaOidGenerator methodsFor: 'accessing' stamp: 'M.U 6/6/1999 00:58'!
highValueCounter: aValue

	highValueCounter := aValue! !

!OperaOidGenerator methodsFor: 'accessing' stamp: 'M.U 6/6/1999 01:04'!
lowValue

	lowValue isNil ifTrue:[ lowValue := self privNextValue. ].

	^lowValue! !

!OperaOidGenerator methodsFor: 'accessing' stamp: 'M.U 6/6/1999 00:49'!
lowValue: aValue

	lowValue := aValue! !


!OperaOidGenerator methodsFor: 'private' stamp: 'MU 11/18/2000 01:22'!
nextHighValue
	self highValueCounter: self highValueCounter + 1.
	self highValueCounter > 9999
		ifTrue: 
			[self highValueCounter: 0.
			self highValue: self privNextValue].
	^ self highValue.! !

!OperaOidGenerator methodsFor: 'private' stamp: 'M.U 6/6/1999 01:02'!
nextLowValue
	self lowValue: self privNextValue.
	^ self lowValue.! !

!OperaOidGenerator methodsFor: 'private' stamp: 'MU 8/19/2000 20:47'!
privNextValue
	| sz str |
	sz := 6.
	str := String new: sz.
	1 to: sz do:[ :idx |
	str at: idx put: 15 atRandom asHexDigit]. 
	^str
	
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaOidGenerator class
	instanceVariableNames: ''!

!OperaOidGenerator class methodsFor: 'instance creation' stamp: 'M.U 6/6/1999 00:41'!
new
	^super new initialize! !


Object subclass: #OperaSingleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaSingleton commentStamp: 'MU 11/12/2000 01:50' prior: 0!
I am an abstract class for singleton. I also have some utilities.!


!OperaSingleton methodsFor: 'initialize-release' stamp: 'MU 11/5/2000 00:06'!
initialize
	"default do nothing"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaSingleton class
	instanceVariableNames: 'default '!

!OperaSingleton class methodsFor: 'class initialization' stamp: 'MU 11/5/2000 00:04'!
initialize
	
	default := nil.
	! !

!OperaSingleton class methodsFor: 'class initialization' stamp: 'MU 11/5/2000 00:05'!
initializeAll
	"OperaSingleton initializeAll"
	
	OperaSingleton allSubclassesDo:[:each | each initialize]
	! !


!OperaSingleton class methodsFor: 'instance creation' stamp: 'MU 11/5/2000 00:05'!
default
	default isNil ifTrue:[default := self new].
	^default! !

!OperaSingleton class methodsFor: 'instance creation' stamp: 'MU 11/5/2000 00:05'!
new
	^super new initialize! !


OperaSingleton subclass: #OperaConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaConnector commentStamp: 'MU 11/12/2000 01:33' prior: 0!
I connect to a Soap-Http Server and return results to stubs (RemoteObject).
Currently I do not support collocation.!


!OperaConnector methodsFor: 'sending' stamp: 'MU 11/26/2000 01:20'!
send: aRemoteMessageSend to: host port: port
	| url env ret |
	
	self processArguments: aRemoteMessageSend arguments.
	
	url := host, ':', port asString.
	env := self wrapSoapEnvelope: aRemoteMessageSend.
	ret := SoapHttpClient sendTo: url request: env printXmlString.

	"Transcript show: ret printString." "##for debug##"
	^self processReturn: ret.! !


!OperaConnector methodsFor: 'private' stamp: 'MU 11/26/2000 01:22'!
processArguments: aCollectionOfArguments
	"##needs more work##"
	"currently obj ref argument is always registerd in root ooa"
	aCollectionOfArguments do:[:each |
		(OperaObjectReference hasInstance: each)
			ifTrue:[ OperaORB rootOOA registerObjectImplFor: each.
					"passing obj ref to server, so impl should be nil"
					each impl: nil.
			]
	].
	^aCollectionOfArguments! !

!OperaConnector methodsFor: 'private' stamp: 'MU 11/18/2000 01:39'!
processReturn: aReturnedXmlString 
	| env msg obj |
	env := SoapEnvelope fromXml: aReturnedXmlString.
	env body hasFault
		ifTrue: [self signalErrorFrom: env body fault].
	msg := env body messages first. "currently only one msg support"

	obj := OperaObjectStream objectFromString: msg result. 
	obj class name == #OperaObjectReference ifTrue:[ obj := obj asRemoteObject]. "sort of obj ref support"
	^obj! !

!OperaConnector methodsFor: 'private' stamp: 'MU 11/26/2000 00:50'!
signalErrorFrom: aSoapFault
	(OperaError fromSoapError: (SoapError fromSoapFault: aSoapFault)) signal! !

!OperaConnector methodsFor: 'private' stamp: 'MU 11/18/2000 01:33'!
wrapSoapEnvelope: aRemoteMessageSend 
	| env msg |
	env := SoapEnvelope fromXml: self class templateEnvelopeXml.
	msg := env body messages first.
	"##need more work##"
	"We need XML schema marshal/unmarshaller for true SOAP interoperability"
	msg name: OperaObjectAdapter dispatchSelectorName.
	msg receiver: OperaObjectAdapter serverName.
	msg
		arguments: (Array
				with: (SoapArgument name: aRemoteMessageSend class name asString value: aRemoteMessageSend storeString)).
	^ env! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaConnector class
	instanceVariableNames: ''!

!OperaConnector class methodsFor: 'constants' stamp: 'MU 11/7/2000 11:38'!
templateEnvelopeXml
	^'
<SOAP-ENV:Envelope
	xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
	SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
	<SOAP-ENV:Body>
		<m:selector xmlns:m="receiver">
			<symbol>value</symbol>
		</m:selector>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>
'.! !


OperaSingleton subclass: #OperaObjectAdapter
	instanceVariableNames: 'namedObjectHome oidGenerator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaObjectAdapter commentStamp: 'MU 11/12/2000 01:34' prior: 0!
I am an object adapter for server.!


!OperaObjectAdapter methodsFor: 'receiving' stamp: 'MU 11/26/2000 02:45'!
dispatch: aStringfiedRemoteMessageSend 
	| message ret |
	message := RemoteMessageSend fromString: aStringfiedRemoteMessageSend.
	message namedObjectHome: self namedObjectHome.
	message arguments
		withIndexDo: [:each :idx | (OperaObjectReference hasInstance: each)
				ifTrue: [message arguments at: idx put: each asRemoteObject]].

	"##need more work##"
	"need error handling for obj ref"
	ret := RemoteReturnValue value: message value.

	"##restrict implicit self return-by-value##"
	ret value == message receiver ifTrue: [^ ret value: (self activateObjectReference: (OperaObjectReference on: ret value)
				named: message receiverName)].

	"##investigate return-by-value or return-by-ref##"
	(OperaObjectReference hasInstance: ret value)
		ifTrue: [^ ret value: (self activateObjectReference: ret value named: ret value name)].

	^ ret! !


!OperaObjectAdapter methodsFor: 'tiny naming service' stamp: 'MU 11/10/2000 13:44'!
at: aSymbol
	^ self namedObjectHome at: aSymbol! !

!OperaObjectAdapter methodsFor: 'tiny naming service' stamp: 'MU 11/10/2000 13:46'!
at: aSymbol ifAbsent: aBlock
	^ self namedObjectHome at: aSymbol ifAbsent: aBlock! !

!OperaObjectAdapter methodsFor: 'tiny naming service' stamp: 'MU 11/18/2000 02:06'!
at: aSymbol ifAbsentPut: aBlock
	^ self namedObjectHome at: aSymbol ifAbsentPut: aBlock! !

!OperaObjectAdapter methodsFor: 'tiny naming service' stamp: 'MU 11/10/2000 13:47'!
at: aSymbol put: anObject 
	^ self namedObjectHome at: aSymbol put: anObject! !


!OperaObjectAdapter methodsFor: 'registering' stamp: 'MU 11/26/2000 01:20'!
registerObjectImplFor: anObjectReference
	| found |
	(OperaObjectReference hasInstance: anObjectReference) ifFalse:[OperaError badParameter; description:'parameter is not object refrence'; signal].
	
	"if found, object has been registered already, so do nothing"
	
	found := self at: anObjectReference name ifAbsent: [].
	found isNil
		ifTrue: 
			[| nm | 
			nm := self nextTempObjectName.
			self at: nm put: anObjectReference impl.
			anObjectReference name: nm].

	^ anObjectReference! !


!OperaObjectAdapter methodsFor: 'accessing' stamp: 'MU 11/10/2000 13:43'!
namedObjectHome
	namedObjectHome isNil ifTrue:[namedObjectHome := NamedObjectHome new].
	^namedObjectHome! !

!OperaObjectAdapter methodsFor: 'accessing' stamp: 'MU 11/10/2000 13:44'!
namedObjectHome: aNamedObjectHome
	namedObjectHome := aNamedObjectHome
	! !

!OperaObjectAdapter methodsFor: 'accessing' stamp: 'MU 11/20/2000 00:37'!
oidGenerator
	oidGenerator isNil ifTrue:[oidGenerator := OperaOidGenerator new].
	^oidGenerator! !

!OperaObjectAdapter methodsFor: 'accessing' stamp: 'MU 11/18/2000 01:24'!
oidGenerator: aNamedObjectHome
	oidGenerator := aNamedObjectHome
	! !


!OperaObjectAdapter methodsFor: 'private' stamp: 'MU 11/26/2000 01:20'!
activateObjectReference: anObjectReference named: aRegisteredObjectName 
	| found |
	"assign object name"
	"implicitly create unshared obj ref name and register"
	found := self at: aRegisteredObjectName ifAbsent: [].
	found isNil
		ifTrue: 
			[| nm | 
			nm := self nextTempObjectName.
			self at: nm put: anObjectReference impl. 
			anObjectReference name: nm]
		ifFalse: [anObjectReference name: aRegisteredObjectName]. 
	^ anObjectReference! !

!OperaObjectAdapter methodsFor: 'private' stamp: 'MU 11/20/2000 00:30'!
nextTempObjectName
	^('temp:', self oidGenerator nextValue) asSymbol! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaObjectAdapter class
	instanceVariableNames: ''!

!OperaObjectAdapter class methodsFor: 'class initialization' stamp: 'MU 11/20/2000 01:11'!
initialize
	"OperaObjectAdapter initialize"
	super initialize.
	self installRootOOA
	! !

!OperaObjectAdapter class methodsFor: 'class initialization' stamp: 'MU 11/10/2000 13:41'!
installRootOOA
	| acceptor soapBroker messageBinding |
	acceptor := self root.
	soapBroker := SoapBroker default export: acceptor as: (self serverName).
	messageBinding := SoapMessageBinding new.
	messageBinding name: (self dispatchSelectorName).
	messageBinding selector: #dispatch:.
	messageBinding addArgument: (SoapArgument
				name: 'RemoteMessageSend'
				dataType: (soapBroker dataTypeNamed: 'string')).
	soapBroker addBinding: messageBinding.
	! !


!OperaObjectAdapter class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 13:40'!
root
	"OperaObjectAdapter root"
	"Returns RootOOA"
	^super default! !


!OperaObjectAdapter class methodsFor: 'constants' stamp: 'MU 11/9/2000 13:16'!
dispatchSelectorName
	^'Dispatch'! !

!OperaObjectAdapter class methodsFor: 'constants' stamp: 'MU 11/9/2000 12:05'!
serverName
	^'RootOOA'! !


OperaSingleton subclass: #OperaSetting
	instanceVariableNames: 'defaultHost defaultPort '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!OperaSetting commentStamp: 'MU 11/12/2000 01:39' prior: 0!
I have settings for SoapOpera. Default hostname, default port number, etc.!


!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:48'!
defaultHost
	defaultHost isNil ifTrue:[defaultHost := 'localhost'].
	^defaultHost! !

!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:47'!
defaultHost: aValue

	defaultHost := aValue! !

!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:49'!
defaultPort
	defaultPort isNil ifTrue:[defaultPort := 8823].
	^defaultPort! !

!OperaSetting methodsFor: 'accessing' stamp: 'MU 11/5/2000 00:47'!
defaultPort: aValue

	defaultPort := aValue! !


MessageSend subclass: #RemoteMessageSend
	instanceVariableNames: 'receiverName namedObjectHome value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!RemoteMessageSend commentStamp: 'MU 11/12/2000 01:47' prior: 0!
I am a MessageSend for RemoteObject

Instance variable names:
 receiverName <Symbol> 
 namedObjectHome <NamedObjectHome>
!


!RemoteMessageSend methodsFor: 'actions' stamp: 'MU 11/10/2000 21:06'!
receiver
	^(self receiverOf: self receiverName)! !


!RemoteMessageSend methodsFor: 'storing' stamp: 'MU 11/7/2000 17:04'!
storeString
	^OperaObjectStream stringFromObject: self! !


!RemoteMessageSend methodsFor: 'accessing' stamp: 'MU 11/10/2000 17:23'!
namedObjectHome
	namedObjectHome isNil ifTrue:[namedObjectHome := NamedObjectHome new].
	^namedObjectHome! !

!RemoteMessageSend methodsFor: 'accessing' stamp: 'MU 11/10/2000 17:22'!
namedObjectHome: aNamedObjectHome
	namedObjectHome := aNamedObjectHome! !

!RemoteMessageSend methodsFor: 'accessing' stamp: 'mu 10/30/2000 14:44'!
receiverName
	^receiverName! !

!RemoteMessageSend methodsFor: 'accessing' stamp: 'mu 10/30/2000 14:44'!
receiverName: anObjectNameSymbol
	receiverName := anObjectNameSymbol! !


!RemoteMessageSend methodsFor: 'evaluating' stamp: 'MU 11/26/2000 01:37'!
value
	"evaluation is occurred only once"
	value isNil ifTrue: [value := arguments isNil
					ifTrue: [self receiver perform: selector]
					ifFalse: [self receiver perform: selector withArguments: arguments]].
	^ value! !


!RemoteMessageSend methodsFor: 'private' stamp: 'MU 11/10/2000 17:23'!
receiverOf: aObjectName
	^self namedObjectHome at: aObjectName! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RemoteMessageSend class
	instanceVariableNames: ''!

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'MU 11/7/2000 17:05'!
fromString: aString
	 ^OperaObjectStream objectFromString: aString.! !

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 14:46'!
receiverName: anObject selector: aSymbol
	^ self receiverName: anObject selector: aSymbol arguments: #()! !

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 14:46'!
receiverName: anObject selector: aSymbol argument: aParameter
	^ self receiverName: anObject selector: aSymbol arguments: (Array with: aParameter)! !

!RemoteMessageSend class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 14:45'!
receiverName: anObject selector: aSymbol arguments: anArray
	^ self new
		receiverName: anObject;
		selector: aSymbol;
		arguments: anArray! !


!RemoteMessageSend class methodsFor: 'constants' stamp: 'MU 11/7/2000 14:41'!
tagName
	^self name! !


ProtoObject subclass: #RemoteObject
	instanceVariableNames: 'name host port '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!RemoteObject commentStamp: 'MU 11/12/2000 01:49' prior: 0!
I am a stub for client.

Instance variable names:
 name <Symbol> object name
 host <String> server host where object imple lives
 port <Integer> server port where object imple lives!


!RemoteObject methodsFor: 'system callback' stamp: 'MU 11/10/2000 20:41'!
doesNotUnderstand: aMessage

	| remoteMsg |
	remoteMsg := RemoteMessageSend receiverName: self oprName selector: aMessage selector arguments: aMessage arguments.
	
	^OperaConnector default send: remoteMsg to: self oprHost port: self oprPort! !


!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/6/2000 00:40'!
oprHost
	host isNil ifTrue:[host := OperaSetting default defaultHost].
	^host! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:21'!
oprHost: aValue

	host := aValue! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:22'!
oprName
	name isNil ifTrue:[name := 'server'].
	^name! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:22'!
oprName: aValue

	name := aValue! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/6/2000 00:40'!
oprPort
	port isNil ifTrue:[port := OperaSetting default defaultPort].
	^port	! !

!RemoteObject methodsFor: 'accessing' stamp: 'MU 11/5/2000 01:22'!
oprPort: aValue

	port := aValue! !


!RemoteObject methodsFor: 'special' stamp: 'MU 11/6/2000 00:47'!
halt
	"useful for debug"

	Halt signal! !

!RemoteObject methodsFor: 'special' stamp: 'MU 11/7/2000 20:22'!
inspect
	"useful for debug"
	| dic |
	dic := IdentityDictionary new.
	dic at: #ClassName put: #RemoteObject.
	dic at: #name put: self oprName.
	dic at: #host put: self oprHost.
	dic at: #port put: self oprPort.
	Inspector openOn:  dic withEvalPane: true withLabel: ('a RemoteObject: ', (self oprName)) asSymbol! !

!RemoteObject methodsFor: 'special' stamp: 'MU 11/18/2000 01:53'!
oprPrintString
	| aStream |
	"useful for debug"
	aStream := (String new: 64) writeStream.
	aStream nextPutAll:  'a RemoteObject( ';
		nextPutAll: self oprName, ' ) ';
		nextPutAll: 'host: ', self oprHost;
		nextPutAll: 'port: ', self oprPort.
	aStream contents
	! !

!RemoteObject methodsFor: 'special' stamp: 'MU 11/18/2000 01:48'!
printOn: aStream
	"useful for debug"
	aStream nextPutAll:  'a RemoteObject( ';
		nextPutAll: self oprName, ' ) ';
		nextPutAll: 'host: ', self oprHost;
		nextPutAll: 'port: ', self oprPort.
	! !

!RemoteObject methodsFor: 'special' stamp: 'MU 11/6/2000 00:48'!
yourself
	"for optimization"

	^self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RemoteObject class
	instanceVariableNames: ''!

!RemoteObject class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:42'!
name: aSymbol host: aHost 
	^self name: aSymbol host: aHost port: nil! !

!RemoteObject class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:42'!
name: aSymbol host: aHost port: aPort 
	| inst |
	inst := self new.
	inst oprName: aSymbol.
	inst oprHost: aHost.
	inst oprPort: aPort.
	^inst! !

!RemoteObject class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 17:43'!
named: aSymbol
	^self name: aSymbol host: nil! !


Object subclass: #RemoteReturnValue
	instanceVariableNames: 'value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!RemoteReturnValue commentStamp: 'MU 11/12/2000 01:49' prior: 0!
I encaptulate return value for wire passing.

!


!RemoteReturnValue methodsFor: 'storing' stamp: 'MU 11/10/2000 20:18'!
storeString
	^OperaObjectStream stringFromObject: self value! !


!RemoteReturnValue methodsFor: 'accessing' stamp: 'mu 10/30/2000 15:15'!
value
	^value! !

!RemoteReturnValue methodsFor: 'accessing' stamp: 'mu 10/30/2000 15:16'!
value: aValue
	value := aValue! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RemoteReturnValue class
	instanceVariableNames: ''!

!RemoteReturnValue class methodsFor: 'instance creation' stamp: 'MU 11/10/2000 20:12'!
fromString: aString
	  ^self value: (OperaObjectStream objectFromString: aString)! !

!RemoteReturnValue class methodsFor: 'instance creation' stamp: 'mu 10/30/2000 15:16'!
value: aValue
	^self new value: aValue! !


Object subclass: #SoapOperaDoc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Opera'!
!SoapOperaDoc commentStamp: 'MU 11/26/2000 19:06' prior: 0!
Documentation and examples for SoapOpera.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapOperaDoc class
	instanceVariableNames: ''!

!SoapOperaDoc class methodsFor: 'documentation' stamp: 'MU 12/28/2000 00:21'!
aboutSoapOpera
"## SoapOpera ## 
SoapOpera is a tiny ORB based on Soap-Http Protocol.

-Prerequisites:

 - VW XML Parser ported by Bijan Parsia(http://minnow.cc.gatech.edu/squeak/1408)
 - A refactored SOAP implementation 
        (included in this release)
        (but original is CS2 SOAP implementation. 
         http://wiki.cs.uiuc.edu/CampSmalltalk/SOAP+Smalltalk+Reference+Implementation)
 - ComSwiki (http://minnow.cc.gatech.edu/swiki)

Enjoy!!

---
[:masashi | ^umezawa] 12/28/2000 00:21
"! !


!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/26/2000 03:06'!
clientExample1
	| john |
	"SoapOperaDoc clientExample1"
	"try changing Cs2Person >> doSomething: to see various results"
	
	"##Client side##"
	" 0: open transcript(to see the results)"
	"OperaORB debugMode: true."
	"OperaORB debugMode: false."

	" 1: create remote object"
	john := RemoteObject named: #John.
	"john := RemoteObject name: #John host:<your server name>. "
	
	" 2: remote message send"
	john doSomething: 'Smalltalk!!!!'.
	
	! !

!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/26/2000 02:32'!
clientExample2
	| john ret |
	"SoapOperaDoc clientExample2"
	
	"##Client side##"
	" 0: open transcript(to see the results)"

	" 1: create remote object"
	john := RemoteObject named: #John.
	"john := RemoteObject name: #John host:<your server name>. "
	
	" 2: remote message send"
	ret := john doSomethingAndReturnSimple: 'Smalltalk!!!!'.
	
	" 3: remote message send (causes error)"
	"john add: #fooBarBaz"
	
	Transcript cr; show: ret printString. 
	
	! !

!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/26/2000 02:32'!
clientExample3
	| john  |
	"SoapOperaDoc clientExample3"
		
	"##Client side##"
	" 0: open transcript(to see the results)"

	" 1: create remote object"
	john := RemoteObject named: #John.
	"john := RemoteObject name: #John host:<your server name>. "
	
	" 2: remote message send (causing server side error)"
	john doBadly: 'not Java'
	! !

!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/26/2000 02:47'!
clientExample4
	| john  ret1 ret2 |
	"SoapOperaDoc clientExample4"
	
	"##Client side##"
	" 0: open transcript(to see the results)"

	" 1: create remote object"
	john := RemoteObject named: #John.
	"john := RemoteObject name: #John host:<your server name>. "
	
	" 2: remote message send"
	ret1 := john doSomethingAndReturnSelf: 'Smalltalk - but sometimes I think we may need void'.
	ret2 := john doSomethingAndReturnSelfCopy: 'Smalltalk'.

	ret1 doSomething: 'Local'. "local copy send"
	ret2 doSomething: 'Remote'. "remote"
	
	" 3: please see the difference"
	ret1 inspect.
	ret2 inspect.
	! !

!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/26/2000 02:47'!
clientExample5
	| john  ret1 ret2 |
	"SoapOperaDoc clientExample5"
	
	"##Client side##"
	" 0: open transcript(to see the results)"

	" 1: create remote object"
	john := RemoteObject named: #John.
	"john := RemoteObject name: #John host:<your server name>. "
	
	" 2: remote message send"
	ret1 := john doSomethingAndReturnObjRef: 'Eiffel'.
	ret2 := john doSomethingAndReturnObjValue: 'Smalltalk'.
	
	ret1 doSomething: 'Remote'. "remote"
	ret2 doSomething: 'Local'. "local copy send"
	
	" 3: please see the difference"
	ret1 inspect.
	ret2 inspect.
	! !

!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/26/2000 02:48'!
clientExample6
	| john paul |
	"SoapOperaDoc clientExample6"
	
	"##Client side##"
	" 0: open transcript(to see the results)"

	" 1: create remote object"
	john := RemoteObject named: #John.
	"john := RemoteObject name: #John host:<your server name>. "
	
	" 2: create object reference"
	paul := OperaObjectReference on: (Cs2Person named: 'Paul').
	
	" 3: remote message send"
	john doSomethingAndArgDoSomething: paul.
	
	! !

!SoapOperaDoc class methodsFor: 'examples' stamp: 'MU 11/26/2000 02:30'!
serverExample1
	"SoapOperaDoc serverExample1"
	
	"##Server side##"
	" 0: open transcript(to see the results)"

	" 1: start OperaORB (actually soap-http server)"
	" *Please start http server manually* (current limitation)"
	OperaORB launch.
	
	" 2: init object adapter ( may be unneeded because file-in do this automatically)"
	OperaORB rootOOA initialize.
	
	" 3: register object implementation"
	OperaORB rootOOA at: #John put: Cs2Person new.
	! !

OperaSingleton initialize!
OperaObjectAdapter initialize!